# class SignallingComponent | Abstract signalling component that can be managed by the engine. More...
Full name | `TelEngine::SignallingComponent`
Definition | `#include <libs/ysig/yatesig.h>`
Inherits | TelEngine::DebugEnabler [public ], TelEngine::RefObject [public ]
Inherited by | AnalogLineGroup, GTT, ISDNIUA, ISDNIUAClient, ISDNLayer2, ISDNLayer3, ISDNQ921, ISDNQ921, ISDNQ921Management, ISDNQ921Management, ISDNQ921Management, ISDNQ921Passive, ISDNQ921Passive, ISDNQ931, ISDNQ931Monitor, SCCP, SCCPManagement, SCCPUser, SIGAdaptClient, SIGAdaptServer, SIGAdaptation, SIGTransport, SS7AnsiSccpManagement, SS7BICC, SS7ISUP, SS7ItuSccpManagement, SS7L2User, SS7L3User, SS7Layer2, SS7Layer3, SS7Layer4, SS7M2PA, SS7M2UA, SS7M2UAClient, SS7M3UA, SS7MTP2, SS7MTP2, SS7MTP3, SS7MTP3, SS7Management, SS7Router, SS7Router, SS7SCCP, SS7SCCP, SS7SUA, SS7TCAP, SS7TCAPANSI, SS7TCAPITU, SS7TUP, SS7Testing, SignallingCircuitGroup, SignallingCircuitSpan, SignallingInterface, SignallingReceiver, TCAPUser
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- virtual ~SignallingComponent ()
- virtual const String& toString () const
- virtual bool initialize (const NamedList* config)
- virtual bool control (NamedList& params)
- virtual NamedList* controlCreate (const char* oper = 0)
- virtual bool controlExecute (NamedList* params)
- virtual void engine (SignallingEngine* eng)
- inline SignallingEngine* engine () const
- inline int debugLevel (int level)
- inline const String& componentType () const

#### Public Static Methods

- static bool resolveConfig (const String& cmpName, NamedList& params, const NamedList* config)

#### Protected Methods

- SignallingComponent (const char* name = 0, const NamedList* params = 0, const char* type = "unknown")
- virtual void destroyed ()
- void insert (SignallingComponent* component)
- virtual void detach ()
- virtual void timerTick (const Time& when)
- void setName (const char* name)
- inline void setCompType (const char* type)
- unsigned long tickSleep (unsigned long usec = 1000000) const

## Detailed Description

Interface to an abstract signalling component that is managed by an engine. The engine will periodically poll each component to keep them alive.

~SignallingComponent () | ### ~SignallingComponent

[virtual]

Destructor, detaches the engine and other components

const String& toString () | ### toString

[const virtual]

Get the component's name so it can be used for list searches

Returns: A reference to the name by which the component is known to engine

Reimplemented from GenObject.

bool initialize (const NamedList* config) | ### initialize

[virtual]

Configure and initialize the component and any subcomponents it may have

Parameters:

config | Optional configuration parameters override

Returns: True if the component was initialized properly

bool resolveConfig (const String& cmpName, NamedList& params, const NamedList* config) | ### resolveConfig

[static]

Choose parameters that should be used for object initialization

Parameters:

cmpName | The name of the parameter holding the component name
params | The list of parameters used to initialize the component
config | The received list of parameters

Returns: True if the config was resolved

bool control (NamedList& params) | ### control

[virtual]

Query or modify component's settings or operational parameters

Parameters:

params | The list of parameters to query or change

Returns: True if the control operation was executed

NamedList* controlCreate (const char* oper = 0) | ### controlCreate

[virtual]

Create a parameter list adequate to control this component

Parameters:

oper | Optional name of the operation to execute

Returns: A new parameter list or descendant object, NULL if not supported

bool controlExecute (NamedList* params) | ### controlExecute

[virtual]

Execute or postpone a control command

Parameters:

params | Parameter list describing the command, will be destroyed

Returns: True if the command was accepted (but not necessarily executed)

void engine (SignallingEngine* eng) | ### engine

[virtual]

Set the TelEngine::SignallingEngine that manages this component and any subcomponent of it

Parameters:

eng | Pointer to the engine that will manage this component

inline SignallingEngine* engine () | ### engine

[const]

Get the TelEngine::SignallingEngine that manages this component

Returns: Pointer to engine or NULL if not managed by an engine

inline int debugLevel (int level) | ### debugLevel

Conditionally set the debug level of the component

Parameters:

level | Desired debug level, negative for no change

Returns: Current debug level

Reimplemented from DebugEnabler.

inline const String& componentType () | ### componentType

[const]

Return the type of this component

Returns: A string version of the component type

SignallingComponent (const char* name = 0, const NamedList* params = 0, const char* type = "unknown") | ### SignallingComponent

[protected]

Constructor with a default empty component name

Parameters:

name | Name of this component
params | Optional pointer to creation parameters
type | Default component type string

void destroyed () | ### destroyed

[protected virtual]

This method is called to clean up and destroy the object after the reference counter becomes zero

Reimplemented from RefObject.

void insert (SignallingComponent* component) | ### insert

[protected]

Insert another component in the same engine as this one. This method should be called for every component we attach.

Parameters:

component | Pointer to component to insert in engine

void detach () | ### detach

[protected virtual]

Detach this component from all its links - components and engine. Reimplement this method in all components that keep pointers to other components. The default implementation detaches from the engine.

void timerTick (const Time& when) | ### timerTick

[protected virtual]

Method called periodically by the engine to keep everything alive

Parameters:

when | Time to use as computing base for events and timeouts

void setName (const char* name) | ### setName

[protected]

Change the name of the component after it was constructed

Parameters:

name | Name of this component

inline void setCompType (const char* type) | ### setCompType

[protected]

Change the type of the component after it was constructed

Parameters:

type | Type of this component

unsigned long tickSleep (unsigned long usec = 1000000) | ### tickSleep

[protected const]

Adjust (decrease only) the desired maximum time until next tick. Can be called only from within timerTick()

Parameters:

usec | Desired time until next engine's timerTick() call in usec

Returns: Timer sleep in usec after applying the current change

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.